class Editor.PanelEditor.Dialog extends Backbone.View
  tagName: 'div'
  className: 'panel-editor-dialog'
  
  initialize: (options) ->
    @parent = options.parent
    @target_model = options.target_model
    @history = new Pettanr.Views.History({parent: this})
    @listenTo(@history, 'http_get', @http_get)
    @listenTo(@history, 'get', @get)
  
  start: (@target_model, params, form) ->
    @get(params, form)
  
  stop: () ->
    this.$el.dialog('close')
  
  render: () ->
    this.$el.html('')
    this
  
  refresh: (view) ->
    this.$el.html('')
    this.$el.append(@history.render().el)
    rb = new Tag.RowBreak()
    this.$el.append(rb.render().el)
    this.$el.append(view.el)
  
  getter_proxy: () ->
    proxy = new Pettanr.PickerProxy({})
    @listenTo(proxy, 'ready', @ready)
    @listenTo(proxy, 'title', @title)
    @listenTo(proxy, 'title', @push_history)
    @listenTo(proxy, 'done', @done)
    @listenTo(proxy, 'deny', @deny)
    proxy
  
  http_get: (url, form) ->
    @getter_proxy().http_get(url, form)
  
  get: (params, form) ->
    @getter_proxy().get(params, form)
  
  ready: (view) ->
    @listenTo(view, 'http_get', @http_get)
    # @listenTo(view, 'http_post', @http_post)
    @listenTo(view, 'pick', @pick)
    if view['is_pickable'] and view.is_pickable()
      view.add_pick(@target_model)
    @refresh(view)
    this.$el.dialog('open')
  
  done: (params) ->
  
  deny: (params, form, safe_url) ->
    @getter_proxy().http_get(safe_url, params, form)
  
  push_history: (params, str = null) ->
    @history.push(params, str)
  
  title: (params, str = null) ->
    t = str || I18n.t(params['controller'] + '.' + params['action'] + '.title')
    this.$el.dialog({title: t})
  
  pick: (item) ->
    @trigger('pick', item)
  
