class Locmare.Profiler extends Backbone.View
  tagName: 'div'
  className: 'profiler'
  
  initialize: (options) ->
    @item_name = options.item_name
    @item = options.item
    # feasible show parsed extend data
      
    @profiler_manifest = LocalManifest.manifest().profilers[@item_name]
    @header = new Locmare.ProfilerModule.Header({profiler: this})
    @columns = new Locmare.ProfilerModule.Column({profiler: this})
    @associations = new Locmare.ProfilerModule.Association({'profiler': this, association_manifest: @profiler_manifest.associations})
    @listenTo(@header, 'http_get', @http_get)
    @listenTo(@associations, 'http_get', @http_get)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@header.render().el)
    this.$el.append(@columns.render().el)
    this.$el.append(@associations.render().el)
    this
  
  peta: () ->
    Manifest.manifest().items[@item_name]
  
  model: () ->
    Manifest.item_name_to_model @item_name
  
  image_dir: () ->
    '/images/'
  
  is_pickable: () ->
    true
  
  add_pick: (target_model) ->
    @header.add_pick(target_model)
    @associations.add_pick(target_model)
  
  http_get: (url) ->
    @trigger('http_get', url)
  
class Locmare.ProfilerModule

 
