class Pettanr.SystemPicture extends Peta.SystemResource
  url: '/system_pictures/'
  
  @singular: () ->
    'SystemPicture'
  
  @plural: () ->
    'SystemPictures'
  
  defaults: {
    id: null
  } 
  
  picture: () ->
    new Pettanr.Cache.Retriever(Pettanr.Picture, @get('picture_id'))
  
  filename: () ->
    @get('id') + '.' + @get('ext')
  
  mime_type: () ->
    'image/' + @get('ext')
  
  r_url: () ->
    '/system_pictures/' + @filename()
  
  opt_img_tag: () ->
    {src: @r_url(), width: @get('width'), height: @get('height')}
  
  tmb_opt_img_tag: () ->
    new Pettanr.Image.SymbolPicture({
      attr: {
        src: @r_url()
      },
      picture: this
    })
  
  symbol_option: () ->
    retriever = @retriever()
    @listenTo(retriever, 'retrieve', @retrieve_symbol)
    retriever.retrieve()
  
  retrieve_symbol: (item) -> 
    @trigger('ready:symbol', item.tmb_opt_img_tag())
  
  initialize: (attr = {}, options = {}) ->
    super(attr, options)
    if @id
      @url = @url + @id
  
