class Pettanr.Cache
  
  constructor: (options) ->
    @operators = options.operators
    @data = {}
    _.extend(this, Backbone.Events)
  
  # return cached items
  store: (items) ->
    if _.isArray(items)
      return_items = _.map items, (item) =>
        r = @restore(item.cache_key())
        r = @store(item) if !r
        r
    else
      item = items
      cached_item = @restore(item.cache_key())
      return_items = if cached_item
        cached_item  # merge?
      else
        @data[item.cache_key()] = item
      @refresh(return_items)
    return_items
  
  restore: (key) ->
    k = if _.isString(key)
      key
    else
      key.cache_key()
    item = @data[k]
    #if item
    #  @refresh(item)
  
  retrieve: (model, id, force) ->
    empty_item = new model({id: id})
    if force
      # query
      empty_item.fetch().done =>
        @trigger('retrieve', empty_item)
    else if id
      # existence item
      item = @store(empty_item)
      if item
        @trigger('retrieve', item)
      else
        empty_item.fetch().done =>
          @store(empty_item)
          @trigger('retrieve', empty_item)
    else
      # new item
      @trigger('retrieve', empty_item)
  
  edit: (model, id) ->
    @listenTo(this, 'retrieve', @edit_retrieve)
    @retrieve(model, id)
  
  edit_retrieve: (item) ->
    editting_item = item.clone()
    # get latest item
    editting_item.fetch().done =>
      @trigger('edit', editting_item)
  
  refresh: (item) ->
    if item.expire_time
      if Date.now() >= return_items.expire_time
        @sync(item)
    item
  
  sync: (item) ->
    item.fetch().done =>
      item.expire_time.setTime(Date.now() + 10 * 60 * 1000)
  
class Pettanr.Cache.Retriever
  
  constructor: (@model, @id) ->
    _.extend(this, Backbone.Events)
  
  retrieve: (force) ->
    empty_item = new @model({id: @id})
    if force
      # query
      empty_item.fetch().done =>
        @trigger('retrieve', empty_item)
    else if @id
      # existence item
      item = Pettanr.cache.restore(empty_item)
      if item
        @trigger('retrieve', item)
      else
        empty_item.fetch().done =>
          Pettanr.cache.store(empty_item)
          @trigger('retrieve', empty_item)
    else
      # new item
      @trigger('retrieve', empty_item)
  
