class Pettanr.Views.Balloon.Element extends Backbone.View
  tagName: 'img'
  className: 'pettanr-balloon'
  events: {
    'ready:picture': 'set_style'
  }
  
  initialize: (options) ->
    @element = options.element
    @root = options.root
    @spot = options.spot
    @speech_balloon = options.parent
  
  clear: () ->
    retriever = @element.system_picture()
    @listenTo(retriever, 'retrieve', @retrieve_system_picture)
    retriever.retrieve()
    this
  
  retrieve_system_picture: (@system_picture) ->
    @render()
  
  render: () ->
    @set_style()
    this
  
  set_style: () ->
    attr = {
      src: @system_picture.r_url(), 
      alt: @element.get('caption'),
      style: Pettanr.to_style(@style())
    }
    this.$el.attr(attr)
  
  style: () ->
    {
      'width': '100%',
      'height': '100%',
      'z-index': 1  # play case
    }
  
  add_element: (element) ->
    null
  
class Pettanr.Views.Balloon.Element.Edit extends Pettanr.Views.Balloon.Element
  
  initialize: (options) ->
    super(options)
    @listenTo(@element, 'input:system_picture_id', @input_r)
    @listenTo(@element, 'input:width', @resize)
    @listenTo(@element, 'input:height', @resize)
  
  render: () ->
    super()
    sb = @speech_balloon
    elm = @element
    this.$el.resizable {
      stop: (event, ui) ->
        resize_div = $(@)
        speech_balloon_div = sb.$el
        
        resize_div.css('top', '0px')
        resize_div.css('left', '0px')
        resize_div.css('z-index', 1)
        width = ui.size.width
        height = ui.size.height
        top = speech_balloon_div.position().top
        if ui.originalPosition.top != ui.position.top
          top += ui.position.top
          speech_balloon_div.css('top', top.toString() + 'px')
          speech_balloon_div.css('height', height + 'px')
        left = speech_balloon_div.position().left
        if ui.originalPosition.left != ui.position.left
          left += ui.position.left
          speech_balloon_div.css('left', left.toString() + 'px')
          speech_balloon_div.css('width', width + 'px')
        speech_balloon_div.css('width', width.toString() + 'px')
        speech_balloon_div.css('height', height.toString() + 'px')
        elm.set({
          x: Math.floor(left), 
          y: Math.floor(top), 
          width: width, 
          height: height
        }, {silent: true})
        elm.trigger('resize')
     resize: (event, ui) ->
        resize_div = $(@)
        speech_balloon_div = resize_div.parent()
      handles: 'all',
      autoHide: true
    }
    this
  
  input_r: () ->
    @clear()
    resize_div = this.$el.parent()
    resize_div.css('z-index', 1)
  
  resize: () ->
    resize_div = this.$el.parent()
    resize_div.css('width', '100%')
    resize_div.css('height', '100%')
    this.$el.css('width',  '100%')
    this.$el.css('height', '100%')
  
