class Pettanr.Views.OriginalPicture.Publish extends Backbone.View
  
  initialize: (options) ->
    super(options)
    @file_item = options.file_item
    @my_manifest = options.my_manifest
    @item = options.item
    # if item.resource_picture
    # @resource_picture.destroy_url()
    @stop_btn = new Tag.A({
      attr: {href: '/' + @item.destroy_url()}, 
      content: I18n.t('original_pictures.index.stop')
    })
    @edit_icon = new Pettanr.Image.SymbolImg({
      attr: {'src': @edit_img_file_name()}, 
      half: true
    })
    @edit_btn = new Tag.A({
      attr: {href: '/' + @item.edit_url()}, 
      content: @edit_icon.render().el
    })
    @remove_icon = new Pettanr.Image.SymbolImg({
      attr: {'src': @remove_img_file_name()}, 
      half: true
    })
    @remove_btn = new Tag.A({
      attr: {href: '/' + @item.destroy_url()}, 
      content: @remove_icon.render().el
    })
    @listenTo(@edit_btn, 'click', @click_edit)
    @listenTo(@remove_btn, 'click', @click_remove)
  
  render: () ->
    this.$el.html('')
    if @is_own()
      this.$el.append(@stop_btn.render().el)
      this.$el.append(@edit_btn.render().el)
      this.$el.append(@remove_btn.render().el)
    this
  
  is_own: () ->
    if @item.is_own()
      true
    else
      false
   
  filer: () ->
    @file_item.filer()
  
  manifest: () ->
    @filer().manifest
  
  item_name: () ->
    @filer().item_name
  
  image_dir: () ->
    @filer().image_dir()
  
  edit_img_file_name: () ->
    @image_dir() + 'edit.png'
  
  remove_img_file_name: () ->
    @image_dir() + 'remove.png'
  
