class DemanderStatusesController < ApplicationController
  before_filter :authenticate_admin!, :only => [:index, :show, :edit, :update, :destroy]

  def index
    @page = DemanderStatus.page params[:page]
    @page_size = DemanderStatus.page_size params[:page_size]
    @hide = params[:hide]
    @demander_statuses = if @hide.blank?
      DemanderStatus.list(@page, @page_size)
    else
      DemanderStatus.requested_list(@page, @page_size)
    end

    respond_to do |format|
      format.html # index.html.erb
      format.json { render :json => @demander_statuses.to_json(DemanderStatus.list_json_opt) }
    end
  end

  def show
    @demander_status = DemanderStatus.show(params[:id], @admin)

    respond_to do |format|
      format.html # show.html.erb
      format.json { render :json => @demander_status.to_json(DemanderStatus.show_json_opt) }
    end
  end

  def edit
    @demander_status = DemanderStatus.edit(params[:id], @admin)
    respond_to do |format|
      format.html 
    end
  end

  def update
    @demander_status = DemanderStatus.edit(params[:id], @admin)
    respond_to do |format|
      if @demander_status.approve params[:demander_status][:receive_hour1], params[:demander_status][:receive_hour2]
        flash[:notice] = I18n.t('demander_statuses.flash.notice.approved')
        format.html { redirect_to @demander_status }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @demander_status.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @demander_status = DemanderStatus.edit(params[:id], @admin)
    respond_to do |format|
      if @demander_status.reject
        flash[:notice] = I18n.t('demander_statuses.flash.notice.rejected')
        format.html { redirect_to @demander_status }
        format.json { head :ok }
      else
        flash[:notice] = I18n.t('demander_statuses.flash.notice.not_rejected')
        format.html { redirect_to @demander_status }
        format.json { render json: @demander_status.errors, status: :unprocessable_entity }
      end
    end
  end
  
end
