class StorySheetsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  else
    before_filter :authenticate_reader, :only => [
      :index, :show, :by_story, :by_sheet, :by_author
    ]
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_story
    filer_list
  end
  
  def by_sheet
    filer_list
  end
  
  def by_author
    filer_list
  end
  
  def show
    set_show
    respond_to do |format|
      show_prof_format format
      show_json_format format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    @my_model_class = self.class.model
    @item = @my_model_class.new
    @item.supply_default
    @item.attributes = params[@item.item_name]
    @item.overwrite @operators
    @binder = @my_model_class.binder_model.edit(@item.binder_id, @operators) if @item.binder_id
    @panel = @my_model_class.destination_model.show(@item.destination_id, @operators) if @item.destination_id
    
    leaf_render_create play_story_path(@binder)
  end
  
  def update
    @my_model_class = self.class.model
    @item = @my_model_class.edit(params[:id], @operators)
    ot = @item.t
    @item.attributes = params[@item.item_name]
    @item.overwrite @operators
    @binder = @my_model_class.binder_model.edit(@item.binder_id, @operators) if @item.binder_id
    # no check permission for destination
    # swapable hidden panel
    #@panel = @my_model_class.destination_model.show(@item.destination_id, @operators) if @item.destination_id
    
    leaf_render_update ot, play_story_path(@binder)
  end
  
  def destroy
    @story_sheet = StorySheet.edit(params[:id], @operators)
    @story = Story.edit(@story_sheet.story_id, @operators) if @story_sheet.story_id
    respond_to do |format|
      if @story_sheet.destroy_and_shorten
        flash[:notice] = I18n.t('flash.notice.destroyed', :model => StorySheet.model_name.human)
        format.html { redirect_to play_story_path(@story) }
        format.json { head :ok }
      else
        flash[:notice] = I18n.t('flash.notice.not_destroyed', :model => StorySheet.model_name.human)
        format.html { redirect_to story_sheet_path(@story_sheet) }
        format.json { render json: @story_sheet.errors, status: :unprocessable_entity }
      end
    end
  end
end
