module LocalManifest
  module ProfilerModule
    module AssociationModule
      class HasMany < ManifestBase::Names
        attr :controller_name, :item_name, :action_name
        
        def set_default
          super
        end
        
        def init
          super
          if list_manifest = self.profiler.lists[@name]
            @controller_name = list_manifest.controller_name
            @action_name = list_manifest.action_name
          else
            n = @name.split '.'
            if n.size > 1
              @controller_name = n[0]
              @action_name = n[1]
            else
              ManifestBase::alert_undefined_message 'list', self.module_message
            end
          end
        end
        
        def model
          item_name = Manifest.manifest.controllers[@controller_name].actions[@action_name].item_name
          ::Manifest::item_name_to_model item_name
        end
        
        def association_name
          @parent.profiler_name
        end
        
        def profiler
          @parent.profiler
        end
        
        def profiler_manifest
          @parent.profiler_manifest
        end
        
      end
      
    end
  end
end
