module Manifest
  module ItemModule
    class Boost < ManifestBase::NameValues
      attr :level, :template_name,
        :column_name_for_template_module, :settings_column_name, 
        :foreign_key, :extend_model_class_name, :item_name_for_extend_model, 
        :setter_method_name, :getter_method_name, 
        :extend_module_name
      
      def set_default
        super
        @values['level'] ||= 'post'
        @values['template_name'] ||= @name
        @values['column_name_for_template_module'] ||= @values['template_name'] + '_module_name'
        @values['settings_column_name'] ||= @name + '_settings'
        @values['foreign_key'] ||= @values['template_name'] + '_id'
      end
      
      def init
        super
        @level = @values['level']
        @template_name = @values['template_name']
        @column_name_for_template_module = @values['column_name_for_template_module']
        @settings_column_name = @values['settings_column_name']
        @foreign_key = @values['foreign_key']
        
        @values['item_name_for_extend_model'] ||= @template_name
        @values['setter_method_name'] ||= @values['item_name_for_extend_model'] + '_extend='
        @values['getter_method_name'] ||= @values['item_name_for_extend_model'] + '_extend'
        @extend_model_class_name = @values['extend_model_class_name']
        @item_name_for_extend_model = @values['item_name_for_extend_model']
        @setter_method_name = @values['setter_method_name']
        @getter_method_name = @values['getter_method_name']
        @extend_module_name = @values['extend_module_name']
        unless @extend_module_name
          if @extend_model_class_name
            @extend_module_name = @extend_model_class_name + 'Module'
          else
            ManifestBase.alert_undefined_message 'extend_module_name',  self.module_message
          end
        end
      end
      
    end
  end
end
