module ManifestBase
  class TypeArgs
    attr :parent, :json, :type, :module_name
    
    def initialize parent, json, module_name
      @parent = parent
      @json = json
      @module_name = module_name
      self.set_default
      self.init
    end
    
    def set_default
      @json['args'] ||= {}
      @type = @json['type']
      @args = @json['args']
    end
    
    def init
    end
    
    def module_names
      self.parent.module_names + [@module_name]
    end
    
    def module_message
      ManifestBase.module_message(self.module_names)
    end
    
    def parent_name
      @parent.name
    end
    
    def parent_json
      @parent.json
    end
    
  end
end

