module Peta
  class Element < ElementNestableContent
    self.abstract_class = true
    
    # Dynamic ClassMethods
    
    def self.load_manifest
      super
      return nil if self._skip_load?
      # Class Methods
      pm = Manifest.manifest.models[self.my_peta.parent_item_name].classify
      define_singleton_method("parent_model") do 
        pm
      end
      pfk = self.my_peta.parent_item_name + '_id'
      define_singleton_method("parent_key") do 
        pfk
      end
      # Instance Methods
    end
    
    def self.element?
      true
    end
    
    def self.root_model
      if self.parent_model
        if self.parent_model.element?
          self.parent_model.root_model
        else
          self.parent_model
        end
      else
        self
      end
    end
    
    # Instance Methods
    
    def root
      pi = self.__send__ self.class.parent_model.item_name
      if pi.class.element?
        pi.root
      else
        pi
      end
    end
    
    def own? operators
      self.root.own? operators
    end
    
    def visible? operators
      return false unless self.user_visible? operators
      self.root.visible? operators
    end
    
    def self.list_opt_for_panel
      {}
    end
    
    def self.show_opt_for_panel
      {}
    end
    
    def self.json_opt_for_panel
      {}
    end
    
    def self.panelize elements_attributes
      elements_attributes = [elements_attributes] unless elements_attributes.is_a?(Array)
      hash = {}
      index = 0
      elements_attributes.each do |element_attributes|
        hash[self.to_s.tableize + '_attributes'] ||= {}
        n = if element_attributes['id']
          element_attributes['id'].to_s
        else
          index += 1
          'new' + index.to_s 
        end
        hash[self.to_s.tableize + '_attributes'][n] = element_attributes
      end
      hash
    end
    
    def has_picture?
      false
    end
    
    def has_part?
      false
    end
    
    def parent_key
      self.class.parent_key
    end
    
    def parts
      @parts ||= []
    end
    
    def extend_column
      nil
    end
    
    def extend_element_name
      self.extend_column ? self.attributes[extend_column] : self.element_name
    end
    
    def scenario_template with_engine = false
      self.path_name(with_engine) + '/scenario'
    end
    
    def element_face_template with_engine = false
      self.path_name(with_engine) + '/element_face'
    end
    
    def tag_attributes column = nil, opt = {}
      r = super
      r.merge({'data-parent_dom_id' => self.parent.dom_item_id}) if self.editize?
      r
    end
    
    def merge_opacity s, opacity
      s.merge({
        'opacity' => opacity.to_f/100, 
        'filter' => "alpha(opacity=#{opacity})"
      })
    end
    
    def copy_attributes opt = {}
      r = self.attributes
      r.delete 'id'
      r.delete self.parent_key
      r.delete 't' unless opt[:all]  # no problem at balloon, speech
      r.delete 'z' unless opt[:all]  # no problem at balloon, speech
      r.delete 'created_at'
      r.delete 'updated_at'
      r
    end
    
  end
end

