# -*- encoding: utf-8 -*-
FactoryGirl.define do
  factory :license_cc_by, :class => License do |i|
    i.license_group_module_name 'PettanrCreativeCommonsV30Licenses'
    i.name 'CreativeCommonsV30Licenses:BY@us'
    i.caption 'BY'
    i.system_picture_id 3
    i.url 'http://creativecommons.org/licenses/by/3.0/'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":-1,"reverse":-1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license_cc_bync, :class => License do |i|
    i.license_group_module_name 'PettanrCreativeCommonsV30Licenses'
    i.name 'CreativeCommonsV30Licenses:BY-NC@us'
    i.caption 'BY-NC'
    i.url 'http://creativecommons.org/licenses/by-nc/3.0/'
    i.license_group_settings '{"open":0,"commercial":-1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":-1,"reverse":-1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license_cc_bysa, :class => License do |i|
    i.license_group_module_name 'PettanrCreativeCommonsV30Licenses'
    i.name 'CreativeCommonsV30Licenses:BY-SA@us'
    i.caption 'BY-SA'
    i.url 'http://creativecommons.org/licenses/by-sa/3.0/'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":-1,"reverse":-1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license_cc_byncsa, :class => License do |i|
    i.license_group_module_name 'PettanrCreativeCommonsV30Licenses'
    i.name 'CreativeCommonsV30Licenses:BY-NC-SA@us'
    i.caption 'BY-NC-SA'
    i.url 'http://creativecommons.org/licenses/by-nc-sa/3.0/'
    i.license_group_settings '{"open":0,"commercial":-1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":-1,"reverse":-1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license_cc_bynd, :class => License do |i|
    i.license_group_module_name 'PettanrCreativeCommonsV30Licenses'
    i.name 'CreativeCommonsV30Licenses:BY-ND@us'
    i.caption 'BY-ND'
    i.url 'http://creativecommons.org/licenses/by-nd/3.0/'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":1,"derive":-1,"thumbnail":-1,"gif_convert":-1,"reverse":-1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license_cc_byndnc, :class => License do |i|
    i.license_group_module_name 'PettanrCreativeCommonsV30Licenses'
    i.name 'CreativeCommonsV30Licenses:BY-ND-NC@us'
    i.caption 'BY-ND-NC'
    i.url 'http://creativecommons.org/licenses/by-nc-nd/3.0/'
    i.license_group_settings '{"open":0,"commercial":-1,"official":0,"attribution":1,"derive":-1,"thumbnail":-1,"gif_convert":-1,"reverse":-1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license_pc_by, :class => License do |i|
    i.license_group_module_name 'PettanrPettanCommonsV01Licenses'
    i.name 'PettanCommonsV01Licenses:BY@pettanr'
    i.caption 'BY'
    i.url 'https://github.com/yasushiito/pettanr_pcom_v01_licenses/wiki/BY'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
    trait :with_system_picture do
      after(:build) do |license, evaluator|
        source_url_btn = SystemPicture.find_by_md5('05722b184172adef876604239842c18b') || create(:system_picture_source_url_btn)
        source_url_off_btn = SystemPicture.find_by_md5('00c4246c193c7cec0425d44e34c43828') || create(:system_picture_source_url_off_btn)
        license.system_picture_id = create(:system_picture_license_pc_by).id
      end
    end
    factory :license_pc_by_with_system_picture, traits: [:with_system_picture]
  end
  factory :license_pc_bync, :class => License do |i|
    i.license_group_module_name 'PettanrPettanCommonsV01Licenses'
    i.name 'PettanCommonsV01Licenses:BY-NC@pettanr'
    i.caption 'BY-NC'
    i.url 'https://github.com/yasushiito/pettanr_pcom_v01_licenses/wiki/BY_NC'
    i.license_group_settings '{"open":0,"commercial":-1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
    trait :with_system_picture do
      after(:build) do |license, evaluator|
        source_url_btn = SystemPicture.find_by_md5('05722b184172adef876604239842c18b') || create(:system_picture_source_url_btn)
        source_url_off_btn = SystemPicture.find_by_md5('00c4246c193c7cec0425d44e34c43828') || create(:system_picture_source_url_off_btn)
        license.system_picture_id = create(:system_picture_license_pc_bync).id
      end
    end
    factory :license_pc_bync_with_system_picture, traits: [:with_system_picture]
  end
  factory :license_pc_bysa, :class => License do |i|
    i.license_group_module_name 'PettanrPettanCommonsV01Licenses'
    i.name 'PettanCommonsV01Licenses:BY-SA@pettanr'
    i.caption 'BY-SA'
    i.url 'https://github.com/yasushiito/pettanr_pcom_v01_licenses/wiki/BY_SA'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
    trait :with_system_picture do
      after(:build) do |license, evaluator|
        source_url_btn = SystemPicture.find_by_md5('05722b184172adef876604239842c18b') || create(:system_picture_source_url_btn)
        source_url_off_btn = SystemPicture.find_by_md5('00c4246c193c7cec0425d44e34c43828') || create(:system_picture_source_url_off_btn)
        license.system_picture_id = create(:system_picture_license_pc_bysa).id
      end
    end
    factory :license_pc_bysa_with_system_picture, traits: [:with_system_picture]
  end
  factory :license_pc_byncsa, :class => License do |i|
    i.license_group_module_name 'PettanrPettanCommonsV01Licenses'
    i.name 'PettanCommonsV01Licenses:BY-NC-SA@pettanr'
    i.caption 'BY-NC-SA'
    i.url 'https://github.com/yasushiito/pettanr_pcom_v01_licenses/wiki/BY_NC_SA'
    i.license_group_settings '{"open":0,"commercial":-1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
    trait :with_system_picture do
      after(:build) do |license, evaluator|
        source_url_btn = SystemPicture.find_by_md5('05722b184172adef876604239842c18b') || create(:system_picture_source_url_btn)
        source_url_off_btn = SystemPicture.find_by_md5('00c4246c193c7cec0425d44e34c43828') || create(:system_picture_source_url_off_btn)
        license.system_picture_id = create(:system_picture_license_pc_byncsa).id
      end
    end
    factory :license_pc_byncsa_with_system_picture, traits: [:with_system_picture]
  end
  factory :license_pc_bynd, :class => License do |i|
    i.license_group_module_name 'PettanrPettanCommonsV01Licenses'
    i.name 'PettanCommonsV01Licenses:BY-ND@pettanr'
    i.caption 'BY-ND'
    i.url 'https://github.com/yasushiito/pettanr_pcom_v01_licenses/wiki/BY_ND'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
    trait :with_system_picture do
      after(:build) do |license, evaluator|
        source_url_btn = SystemPicture.find_by_md5('05722b184172adef876604239842c18b') || create(:system_picture_source_url_btn)
        source_url_off_btn = SystemPicture.find_by_md5('00c4246c193c7cec0425d44e34c43828') || create(:system_picture_source_url_off_btn)
        license.system_picture_id = create(:system_picture_license_pc_bynd).id
      end
    end
    factory :license_pc_bynd_with_system_picture, traits: [:with_system_picture]
  end
  factory :license_pc_byndnc, :class => License do |i|
    i.license_group_module_name 'PettanrPettanCommonsV01Licenses'
    i.name 'PettanCommonsV01Licenses:BY-ND-NC@pettanr'
    i.caption 'BY-ND-NC'
    i.url 'https://github.com/yasushiito/pettanr_pcom_v01_licenses/wiki/BY_ND_NC'
    i.license_group_settings '{"open":0,"commercial":-1,"official":0,"attribution":1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
    trait :with_system_picture do
      after(:build) do |license, evaluator|
        source_url_btn = SystemPicture.find_by_md5('05722b184172adef876604239842c18b') || create(:system_picture_source_url_btn)
        source_url_off_btn = SystemPicture.find_by_md5('00c4246c193c7cec0425d44e34c43828') || create(:system_picture_source_url_off_btn)
        license.system_picture_id = create(:system_picture_license_pc_byndnc).id
      end
    end
    factory :license_pc_byndnc_with_system_picture, traits: [:with_system_picture]
  end
  factory :license013, :class => License do |i|
    i.license_group_id 9
    i.license_group_module_name 'PettanrPettanProtectedV01Licenses'
    i.name 'PettanProtectedV01Licenses:BY@pettanr'
    i.caption 'BY'
    i.system_picture_id 15
    i.url 'https://github.com/yasushiito/pettanr_ppro_v01_licenses/wiki/BY'
    i.license_group_settings '{"open":-1,"commercial":-1,"official":0,"attribution":1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":0}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license014, :class => License do |i|
    i.license_group_id 9
    i.license_group_module_name 'PettanrPettanProtectedV01Licenses'
    i.name 'PettanProtectedV01Licenses:BY-SA@pettanr'
    i.caption 'BY-SA'
    i.system_picture_id 16
    i.url 'https://github.com/yasushiito/pettanr_ppro_v01_licenses/wiki/BY_SA'
    i.license_group_settings '{"open":-1,"commercial":-1,"official":0,"attribution":1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":0}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license015, :class => License do |i|
    i.license_group_id 9
    i.license_group_module_name 'PettanrPettanProtectedV01Licenses'
    i.name 'PettanProtectedV01Licenses:BY-TB@pettanr'
    i.caption 'BY-TB'
    i.system_picture_id 17
    i.url 'https://github.com/yasushiito/pettanr_ppro_v01_licenses/wiki/BY_TB'
    i.license_group_settings '{"open":-1,"commercial":-1,"official":0,"attribution":1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license016, :class => License do |i|
    i.license_group_id 9
    i.license_group_module_name 'PettanrPettanProtectedV01Licenses'
    i.name 'PettanProtectedV01Licenses:BY-SA-TB@pettanr'
    i.caption 'BY-SA-TB'
    i.system_picture_id 18
    i.url 'https://github.com/yasushiito/pettanr_ppro_v01_licenses/wiki/BY_SA_TB'
    i.license_group_settings '{"open":-1,"commercial":-1,"official":0,"attribution":1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":1}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license017, :class => License do |i|
    i.license_group_id 10
    i.license_group_module_name 'PettanrPettanPublicV01Licenses'
    i.name 'PettanPublicV01Licenses:BY@pettanr'
    i.caption 'BY'
    i.system_picture_id 19
    i.url 'https://github.com/yasushiito/pettanr_ppub_v01_licenses/wiki/BY'
    i.license_group_settings '{"open":1,"commercial":1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":0}'
    i.credit_picture_settings '{"source_url_btn_id":1}'
  end
  factory :license018, :class => License do |i|
    i.license_group_id 10
    i.license_group_module_name 'PettanrPettanPublicV01Licenses'
    i.name 'PettanPublicV01Licenses:BY-SA@pettanr'
    i.caption 'BY-SA'
    i.system_picture_id 16
    i.url 'https://github.com/yasushiito/pettanr_ppub_v01_licenses/wiki/BY_SA'
    i.license_group_settings '{"open":1,"commercial":1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":0}'
    i.credit_picture_settings '{"source_url_btn_id":1}'
  end
  factory :license019, :class => License do |i|
    i.license_group_id 10
    i.license_group_module_name 'PettanrPettanPublicV01Licenses'
    i.name 'PettanPublicV01Licenses:BY-TB@pettanr'
    i.caption 'BY-TB'
    i.system_picture_id 20
    i.url 'https://github.com/yasushiito/pettanr_ppub_v01_licenses/wiki/BY_TB'
    i.license_group_settings '{"open":1,"commercial":1,"official":0,"attribution":1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":1}'
    i.credit_picture_settings '{"source_url_btn_id":1}'
  end
  factory :license020, :class => License do |i|
    i.license_group_id 10
    i.license_group_module_name 'PettanrPettanPublicV01Licenses'
    i.name 'PettanPublicV01Licenses:BY-SA-TB@pettanr'
    i.caption 'BY-SA-TB'
    i.system_picture_id 21
    i.url 'https://github.com/yasushiito/pettanr_ppub_v01_licenses/wiki/BY_SA_TB'
    i.license_group_settings '{"open":1,"commercial":-1,"official":0,"attribution":1,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":1}'
    i.credit_picture_settings '{"source_url_btn_id":1}'
  end
  factory :license021, :class => License do |i|
    i.license_group_id 11
    i.license_group_module_name 'PettanrPublicDomainV01Licenses'
    i.name 'PublicDomainV01Licenses:PD@pettanr'
    i.caption 'Public Domain'
    i.system_picture_id 22
    i.url 'https://github.com/yasushiito/pettanr_pd_v01_licenses/wiki/PublicDomain'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":0,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":0}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license022, :class => License do |i|
    i.license_group_id 11
    i.license_group_module_name 'PettanrPublicDomainV01Licenses'
    i.name 'PublicDomainV01Licenses:CL@pettanr'
    i.caption 'Copyleft'
    i.system_picture_id 23
    i.url 'https://github.com/yasushiito/pettanr_pd_v01_licenses/wiki/Copyleft'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":0,"derive":1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":0}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
  factory :license023, :class => License do |i|
    i.license_group_id 12
    i.license_group_module_name 'PettanrUnknownV01Licenses'
    i.name 'UnknownV01Licenses:UK@pettanr'
    i.caption 'Unknown'
    i.system_picture_id 24
    i.url 'https://github.com/yasushiito/pettanr_unknown_v01_licenses/wiki/Unknown'
    i.license_group_settings '{"open":0,"commercial":1,"official":0,"attribution":-1,"derive":-1,"thumbnail":1,"gif_convert":1,"reverse":1,"sync_vh":1,"overlap":1,"trackback":0}'
    i.credit_picture_settings '{"source_url_btn_id":1,"source_url_off_btn_id":2}'
  end
end
